-- Chimecho's SB Avatar Workshop
system.setcpuspeed(333) -- full speed on! D:
fc = color.new(240,240,240)
negro = color.new(0,0,0)
splash = image.load("Images/splash.png")
fondo = image.load("Images/fondo.png")
fondo2 = image.load("Images/fondo2.png")
mouse={image.load("Images/mouse.png"),image.load("Images/mouse2.png")}
mouseac=1

function loadin()
	if loadedpercent then loadedpercent = math.min(loadedpercent + 1,170); else loadedpercent = 1; end
	splash:blit(0,0)
	image.drawpbar(10,218,460,8,color.new(255,255,255),color.new(0,70,129),loadedpercent,170);
	screen.flip();
end

splash:blit(0,0)
image.drawpbar(10,218,460,8,color.new(255,255,255),color.new(0,70,129),0,115);
screen.waitvblankstart(5)
tmpsplash=screen.buffertoimage()
screen.clear(negro)

for i=0,255,5 do
	image.blend(0,0,tmpsplash,i)
	screen.flip()
end

tmpsplash:free()

dofile("CSBAW.lua")
dofile("CSBUG.lua")
dofile("explorer.lua")

in_csbaw=true

-- funcin de copiado by DeViaNTe & Chimecho
function copia(ori,dest)

origen = io.open(ori,"rb")
destino = io.open(dest,"wb")

b = origen:seek("end") -- setear cursor al final
origen:seek("set") -- setear cursor al inicio
a = b - origen:seek("cur") -- cuantos bytes mide? (fin - inicio)

while (a>0) do
	rd = origen:read(math.min(a,2048)) -- leer 2048 bytes, si queda menos, leer cuanto queda
	destino:write(rd) -- escribir en destino
	a = b - origen:seek("cur") -- cuanto bytes faltan? (fin - por donde va)
end

destino:flush() -- actualizar
destino:close() -- cerrar
origen:close() -- cerrar

end

function creaparticula (col,siz,xx,yy,xxs,yys,vida,gravedad)
	if not PARTICULAS then
		PARTICULAS = { }
	end
	if table.getn(PARTICULAS) < maxp then
		table.insert(PARTICULAS,{ color = col, size = siz, x = xx, y = yy, xs = xxs, ys = yys, life = vida, grav = gravedad})
	end
end

function pe_startup()
	if PARTICULAS then
		PARTICULAS = nil -- DESTRUIR TABLA SI EXISTE.
		collectgarbage("collect");
	end
	r, g, b = 255, 100, 0
	minspeed, maxspeed = 0, 5
	life = 50
	size = 4
	gravity = 0.25
	amount = 20
	tipo = 1
	angulo = 90
	negro = color.new(0,0,0)
	maxp = 200
	y=56
end

function pe_loop()
	image.drawgradrect(0,0,480,272,color.new(0,0,0,150),color.new(0,0,0,150),color.new(0,0,0,150),color.new(0,0,0,150))
	image.drawfillrect(0,y-1,xo,1,color.new(r,g,b))
	image.drawfillrect(xo-1,y-1,1,1,color.new(255,0,0))
	image.drawfillrect(xo-2,y-1,1,1,color.new(128,128,0))
	if PARTICULAS then
		local borradas = 0
		for i = 1, maxp do
			local x = i - borradas
			if x < table.getn(PARTICULAS) then
				PARTICULAS[x].ys = PARTICULAS[x].ys + PARTICULAS[x].grav -- VELOCIDAD Y = VELOCIDAD Y + GRAVEDAD.
				PARTICULAS[x].x = PARTICULAS[x].x + PARTICULAS[x].xs     -- X = X + VELOCIDAD X
				PARTICULAS[x].y = PARTICULAS[x].y + PARTICULAS[x].ys     -- Y = Y + VELOCIDAD Y
				PARTICULAS[x].life = PARTICULAS[x].life - 1			  -- CUENTA ATRS HACIA SU MUERTE...
				if PARTICULAS[x].life <= 0 then
					table.remove(PARTICULAS,x)
					borradas = borradas + 1
				else
					image.drawfillrect(PARTICULAS[x].x,PARTICULAS[x].y,PARTICULAS[x].size,PARTICULAS[x].size,PARTICULAS[x].color)
				end
			end
		end
	end
	local xs = math.random(0,5) + math.random()
	if math.random(0,1) == 1 then
		xs = -xs
	end
	local ys = math.random(2,7) + math.random()
	ys = -ys
	if xo<=480 then
		creaparticula(color.new(r,g,b),2,xo,y,xs,ys,life,gravity)
	end
 end

math.randomseed(os.time())
pe_startup()

controls.homepopup(0) -- no quiero que salgan de mi homebrew sin ver los crditos '

aX = 242
aY = 215
vel = 64
tipomouse="digital" -- analogo o digital?

function mousein(x1,y1,w,h)
local bool = false

if type(w)=="userdata" then
h=w:height()
w=w:width()
end

if aX>=x1 and aX<=x1+w and aY>=y1 and aY<=y1+h then
bool=true
end
return bool
end

function movemouse(cond)

if (not controls.l()) and (not cond) then
	if tipomouse=="analogo" then
		if math.abs(controls.ax())>65 then
			aX = aX + controls.ax()/vel
		end
	
		if math.abs(controls.ay())>65 then
			aY = aY + controls.ay()/vel
		end
	
		if math.abs(controls.ax())>65 or math.abs(controls.ay())>65 then
			if vel>=25 then
				vel=vel-0.5 -- ir bajando desaceleracion, va ms rpido a medida que se mueve!
			end
		else
			vel=64 -- si no se mueve, reiniciar desaceleracion
		end
	elseif tipomouse=="digital" then
		if controls.right() then
			aX = aX + 128/vel
		end
		
		if controls.left() then
			aX = aX - 128/vel
		end
	
		if controls.down() then
			aY = aY + 128/vel
		end
		
		if controls.up() then
			aY = aY - 128/vel
		end
	
		if controls.right() or controls.left() or controls.down() or controls.up() then
			if vel>=25 then
				vel=vel-0.5 -- ir bajando desaceleracion, va ms rpido a medida que se mueve!
			end
		else
			vel=64 -- si no se mueve, reiniciar desaceleracion
		end
	end
end

if aX<=0 then
	aX=0
elseif aX>=479 then
	aX=479
end

if moviendose then
	if aY<=0 then
		aY=0
	elseif aY>=244 then
		aY=244
	end
else
	if aY<=0 then
		aY=0
	elseif aY>=271 then
		aY=271
	end
end

aX=math.floor(aX)
aY=math.floor(aY)

mouse[mouseac]:blit(aX,aY)
end

dblclk=0
dblclkt=timer.new()
dblclkt:reset(0)
dblclkt:stop()

running = true;

-- dev fade-in
controls.read()
dblclk=0

splash:blit(0,0)
image.drawpbar(10,218,460,8,color.new(255,255,255),color.new(0,70,129),115,115)
screen.flip()
screen.waitvblankstart(5)
tmpsplash = screen.toimage()

for i = 255,0,-5 do
CSBAW()
movemouse(true)
image.blend(0,0,tmpsplash,i)
screen.flip()
end

tmpsplash:free()

while running do
controls.read()
dblclk=0
if controls.press("cross") then
	if dblclkt:time()/1000<=0.8 then
		dblclk=1
		dblclkt:reset(0)
		dblclkt:stop()
	elseif dblclkt:time()/1000>0.8 and dblclkt:time()/1000<=100 then
		dblclk=2
		dblclkt:reset(0)
		dblclkt:stop()
	elseif dblclkt:time()/1000>100 then
		dblclk=0
		dblclkt:reset(0)
		dblclkt:stop()
	end
	dblclkt:reset(0)
	dblclkt:stop()
	dblclkt:start()
end

if controls.press("square") then -- cambiar a square simplemente
	if tipomouse=="digital" then
		tipomouse="analogo"
	else
		tipomouse="digital"
	end
end

if in_csbaw then
	CSBAW()
else
	CSBUG()
end
screen.flip()
--screen.waitvblankstart() --Turbo on! xD
end

-- Creditos
creditos = {
	"Cdigo y Grficos:",
	"",
	"Chimecho (Code & Grficos)",
	"DeViaNTe (Code)",
	"RG4M3R (Grficos)",
	"-Adolso-Gallardo- (Grficos)",
	"",
	"",
	"",
	"Betatesters:",
	"",
	"DeViaNTe",
	"A-C2",
	"Gomasz--",
	"boujack25",
	"Deutsche Brayy",
	"ipn2",
	"Arber",
	"jaiminhio_milhan",
	"-Adolso-Gallardo-",
	"",
	"",
	"",
	"Visita:",
	"",
	"psp.scenebeta.com",
	"www.gcrew.es"
}

tmp = screen.toimage();
for i = 0,255,5 do
	image.blend(0,0,tmp,255);
	image.drawgradrect(0,55,480,217,color.new(0,0,0,math.min(i,128)),color.new(0,0,0,math.min(i,128)),color.new(0,0,0,i),color.new(0,0,0,i));
	screen.flip();
end

Ysize = (table.getn(creditos) * 20);
for i=272,(190 - (Ysize*1.1)), - 0.5 do
	controls.read();
	image.blend(0,0,tmp,255);
	image.drawgradrect(0,55,480,217,color.new(0,0,0,128),color.new(0,0,0,128),color.new(0,0,0,255),color.new(0,0,0,255));
	screen.clip(0,55,480,217);
	for x = 1, table.getn(creditos) do
		screen.print(10,math.max(i,(220 - (Ysize*1.1))) + x*20,creditos[x],1,color.new(255,255,255),0x0);
	end
	screen.clip();
	screen.flip();
end

rtmp = screen.toimage();

-- fadeout
for i = 0, 255, 5 do
	rtmp:blit(0,0);
	image.drawfillrect(0,0,480,272,color.new(0,0,0,i));
	screen.flip();
end
